#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "solve.h"
#define e 0

void do_colom(double *m, int size, int st)
{
 int i,k,l,p;
 double a,b,r,yi,yj;
  for(i=st+1;i<size;i++)
   {
     r=sqrt(m[st*(size+2)]*m[st*(size+2)]+m[i*(size+1)+st]*m[i*(size+1)+st]);
      if (r-fabs(m[st*(size+2)])<=e) continue; //viroshdenie
     a=m[st*(size+2)]/r;//cos
     b=-m[i*(size+1)+st]/r;//sin
      for (k=st;k<=size;k++)
       {
        l=st*(size+1);
	p=i*(size+1);
        yi=m[l+k]*a-m[p+k]*b;
        yj=m[l+k]*b+m[p+k]*a;
        m[l+k]=yi;
        m[p+k]=yj;
       }    
   }
}

void write_matrix(double *m,int size)
{
 int i,j;
   for (i=0; i<size; i++)
   {
     for (j=0; j<=size; j++)
      printf("%le  ",m[i*(size+1)+j]);
    printf("\n");
   }     
}

int gauss(double *m, int size, double *x)
{
 int i,j;
  for (i=size-1;i>=0;i--)
   {
    x[i]=m[i*(size+1)+size];
     for (j=i+1;j<size;j++)
      x[i]-=x[j]*m[i*(size+1)+j];
     if (fabs(m[i*(size+2)])<=e) return 10;
    x[i]/=m[i*(size+2)];
   }      
   return 0;
}

int solve(double *m, int size, double *x)
{
 int i;
  for(i=0;i<size-1;i++)
   do_colom(m,size,i);
 return gauss(m,size,x); 
}

void nev(double *m, int size, double *x, double *z)
{
 int i,j;
 double y;
 *z=0;
  for (i=0;i<size;i++)
   {
    y=-m[i*(size+1)+size];
     for (j=0;j<size;j++)
      y+=m[i*(size+1)+j]*x[j];
    (*z)+=y<0? -y:y;  
   }
}   

