//     
// grace-zein (  + tbind)

system-include <tc.h>

system-include <stdio.h>
system-include <stdlib.h>
system-include <math.h>
#include "vr.h"

//    0
#define E 1e-17

//   (    )
//       size 
// 
#define LAST(size,n,rank) (size/n+(size%n>rank ? 1:0)) 
#define FIRST LAST

// 
#define LEN ((SIZE+1)*(SIZE/N+(SIZE%N?1:0)))

// 
struct Matrix 
 { 
  double val[LEN];
 };

//    
struct String
 {
  double str[SIZE+1];
 }; 
 
//  
struct Answer
 {
  double str[SIZE];
 }; 

//      t-
struct List
 {
  struct String tptr string;
  struct List tptr next;
 };   
 
// tptr    
struct Pointer
 {
  struct Matrix tptr matr[N];
 }; 
 
//    
struct Arr_List
 {
  struct List tptr arr[N];
 };

//      
double get_fun(int i, int j)
{
// return (i==j?1:0);
 return fabs(i-j);
} 

#ifdef SEND_LOG
//   

#define R 1
#define S 0

tfun void pr_data(int what, int from,int to, int col,struct String tptr string,tout int * res)
{
 int i;
  if (what==R)
    printf("RESV ");
  else
    printf("SEND ");
 printf("from %d to %d col=%d data:\n",from,to,col);       
  for (i=0;i<SIZE+1;i++)
    printf("%le ",string->str[i]);
 printf("\n--------------\n\n");    
 *res=1;
} 

void pr_str(int what,int from,int to, int col,double * data)
{
 struct String tptr string;
 tval int res;
 int i;
 string=tnew(struct String);
  for (i=0;i<=SIZE;i++)
   string->str[i]=data[i];
  tvalidate(*string);
 TCALL(pr_data(what,from,to, col,string,&res),(0,GR_CI_SYSTEM | GR_CI_FIXED));
 (int)res;
}
#endif

//  
tfun void init(tout struct Pointer * pointer)
{
 int i,j;
 int block, str;
 
 for (i=0;i<N;i++)
  pointer->matr[i]=tnew(struct Matrix);
  
 for (i=0;i<SIZE;i++)
   {
    block=i%N;
    str=i/N;
    pointer->matr[block]->val[str*(SIZE+1)+SIZE]=0; 
     for (j=0;j<SIZE;j++)
      {
       pointer->matr[block]->val[str*(SIZE+1)+j]=get_fun(i,j);
       pointer->matr[block]->val[str*(SIZE+1)+SIZE]+=(j%2?0:1)*get_fun(i,j); 
      }
   }
 
 for (i=0;i<N;i++)
  tvalidate(*pointer->matr[i]);
  
 tvalidate (*pointer); 
   
}

// 
tfun void pr_nev(double z,tout int * res)
{
 printf(" = %le\n",z);
 *res=1;
} 


// 
tfun void pr_ans(struct Answer x, tout int * res)
{
 int i;
 printf("\n-----------------------------Answer-------------------\n");
  
  for (i=0;i<SIZE;i++)
   printf("%lf  ",x.str[i]);
 printf("\n");
 *res=1;
}   


//  
tfun void pr_all(struct Pointer pointer, tout int * res)
{
 int i,j;
 int block, str;
 
 printf("\n--------------------------------\n");
 
 for (i=0;i<SIZE;i++)
   {
    block=i%N;
    str=i/N;
     for (j=0;j<SIZE;j++)
       printf("%le  ",pointer.matr[block]->val[str*(SIZE+1)+j]);
    printf("|  %le  \n",pointer.matr[block]->val[str*(SIZE+1)+SIZE]); 
   }

 *res=1;   
}

//  
void calculate(double *m, int size, int p, int rank,int col,int first, int last)
{
 int line,i;
 double a,b,r,ycol,yline;

   for (line=first+1;line<last;line++)
   {

//     
     {
       r=sqrt(m[first*(size+1)+col]*
              m[first*(size+1)+col]+
              m[line*(size+1)+col]*
              m[line*(size+1)+col]);	      
	if (r<=E)
	 {
	  b=0; a=1; 
	 }
	else
	 {      
          a=m[first*(size+1)+col]/r;/*cos*/
          b=-m[line*(size+1)+col]/r;/*sin*/
	 } 
     }  
     
//        
     for (i=col;i<size+1;i++)
      {
       ycol=m[first*(size+1)+i]*a-
       m[line*(size+1)+i]*b;
       yline=m[first*(size+1)+i]*b+
       m[line*(size+1)+i]*a;
       
       m[first*(size+1)+i]=ycol;
       m[line*(size+1)+i]=yline;
      }
    }
}

// 
void do_string(double * s1, double * s2, int size, int col)
{
 int j;
 double a,b,r,ycol,yline;
 r = sqrt (s1[col]*s1[col]+s2[col]*s2[col]);
  if (r<=E)
    {
     b=0; a=1;
    }
  else
    {
     a=s1[col]/r;
     b=-s2[col]/r;
    }      
  for (j=col;j<size;j++)
   {
    ycol=s1[j]*a-s2[j]*b;
    yline=s1[j]*b+s2[j]*a;
    
    s1[j]=ycol;
    s2[j]=yline;
   }    
}

//   
tfun void gauss(struct Pointer results,int size,tout struct Answer * x_, tout int *res)
{
 int i,j;
 double x[size];
  for (i=size-1;i>=0;i--)
   {
    x[i]=results.matr[i%N]->val[(i/N)*(size+1)+size];
     for (j=i+1;j<size;j++)
      x[i]-=x[j]*results.matr[i%N]->val[(i/N)*(size+1)+j];
     if (fabs(results.matr[i%N]->val[(i/N)*(size+1)+i])<=E) 
      {
       *res=10;
       return;
      } 
    x[i]/=results.matr[i%N]->val[(i/N)*(size+1)+i];
   }      

   *res=0;
   
 for (i=0;i<size;i++)
  x_->str[i]=x[i];
 tvalidate(*x_);
    
}

tfun void nev(struct Pointer pointer, int size, struct Answer x_, tout double *z_)
{
 int i,j;
 double y;
 double z=0;
  for (i=0;i<size;i++)
   {
    y=-pointer.matr[i%N]->val[(i/N)*(size+1)+size];
     for (j=0;j<size;j++)
      y+=pointer.matr[i%N]->val[(i/N)*(size+1)+j]*(x_.str[j]);
    z+=fabs(y);  
   }
 *z_=z;  
}   

// t-
//,  ,  ,   
//Tout:   
tfun void count (int rank_,struct Matrix tptr m_, \
                 struct Arr_List _array, \
		 tout struct List * _list, tout struct Matrix * outM)
{
 struct Arr_List array;
 struct List tptr list = _list;
 struct List tptr next;
 int i,j,k;
 double * value;
 int first, last;
 double * m;
 int arbitr;
 int rank=rank_;

  for (i=0;i<LEN;i++)
     outM->val[i]=m_->val[i];
 
  for (i=0;i<N;i++)
   array.arr[i]=_array.arr[i];

#ifdef LOG   
 tmesg("   %d\n",rank);
#endif

//:     
 m=(double*)(outM->val);
 
//   
 last=LAST(SIZE,N,rank);
  for (i=0;i<SIZE-1;i++)
   {
    first=LAST(i,N,rank);
//      
    calculate(m,SIZE,N,rank,i,first,last);
//  ?
    if (first==last)
     {
      tvalidate(*outM);
      return;
     }      
//     ?
    arbitr=i%N;
//          
     if (arbitr==rank)
      {

       for (j=0;j<N;j++)
        {
	  if (j==arbitr) continue; //    
	  if (FIRST(i,N,j)==LAST(SIZE,N,j)) continue; //  
            /*----------------------SEND---------------------------------------*/   
              list->string=tnew(struct String);   
	        for(k=i;k<=SIZE;k++)
                 list->string->str[k]=m[first*(SIZE+1)+k];
#ifdef SEND_LOG
	    pr_str(S,rank,j,i,m+first*(SIZE+1));
#endif	    	      		 
               tvalidate(* (list->string) );
              list->next=tnew(struct List);
              tbind(*(list->next));
              next=list->next;
              tvalidate(*list);
              list=next;
#ifdef LOG	      
                if (i%IO_CONST==0)
                 tmesg("0 ARBITR SEND Rank = %d to=%d col=%d \n",rank,j,i);//
#endif		 
            /*----------------------Send DONE----------------------------------*/     
    
            /*----------------------RECV---------------------------------------*/   
     
              next=mkconst(array.arr[j])->next;
              (double)mkconst(array.arr[j])->string->str[0];
	      value=(double*)mkconst(array.arr[j])->string->str;
#ifdef SEND_LOG
	    pr_str(R,j,rank,i,value);
#endif	    	      
	      do_string(m+first*(SIZE+1),value,SIZE+1,i);
              array.arr[j]=next; 
#ifdef LOG	      
                if (i%IO_CONST==0)
                 tmesg("1 ARBITR RECV Rank = %d from=%d col=%d \n",rank,j,i);//
#endif		 
	    /*----------------------RECV DONE-----------------------------------*/   
     
         }


    }
    else//   
     { 
//  	  
      
            /*----------------------SEND---------------------------------------*/   
              list->string=tnew(struct String);   
	        for(k=i;k<=SIZE;k++)
                 list->string->str[k]=m[first*(SIZE+1)+k];
#ifdef SEND_LOG
	    pr_str(S,rank,arbitr,i,m+first*(SIZE+1));
#endif	    	      		 
		 
               tvalidate(* (list->string) );
              list->next=tnew(struct List);
              tbind(*(list->next));
              next=list->next;
              tvalidate(*list);
              list=next;
#ifdef LOG	      
                if (i%IO_CONST==0)
                 tmesg("2 SEND TO ARB Rank = %d to=%d col=%d \n",rank,j,i);//
#endif		 
            /*----------------------Send DONE----------------------------------*/     
 

       for (j=0;j<N;j++)
        {
	  if (j==rank) continue; //    
	  if (FIRST(i,N,j)==LAST(SIZE,N,j)) continue; //  
//,     
          if ((j!=arbitr)&&(j!=rank))    
	  {
            /*----------------------RECV---------------------------------------*/   
     
              next=mkconst(array.arr[j])->next;
              array.arr[j]=next; 
#ifdef LOG	      
                if (i%IO_CONST==0)
                 tmesg("3 RECV SKIP Rank = %d from=%d col=%d \n",rank,j,i);//
#endif		 
	    /*----------------------RECV DONE-----------------------------------*/   
            /*----------------------RECV---------------------------------------*/   
     
              next=mkconst(array.arr[arbitr])->next;
              array.arr[arbitr]=next; 
#ifdef LOG	      
                if (i%IO_CONST==0)
                 tmesg("4 RECV ARB SKIP Rank = %d from=%d col=%d \n",rank,j,i);//
#endif		 
	    /*----------------------RECV DONE-----------------------------------*/   
           }
//  	   
	   else
	   {
            /*----------------------RECV---------------------------------------*/   
     
              next=mkconst(array.arr[arbitr])->next;
              (double)mkconst(array.arr[arbitr])->string->str[0];
	      value=(double*)mkconst(array.arr[arbitr])->string->str;
#ifdef SEND_LOG
	    pr_str(R,rank,j,i,value);
#endif	    	      	      
	      do_string(value,m+first*(SIZE+1),SIZE+1,i);
	      // 
              array.arr[arbitr]=next; 
#ifdef LOG	      
                if (i%IO_CONST==0)
                 tmesg("5 RECV ARB Rank = %d from=%d col=%d \n",rank,j,i);//
#endif		 
	    /*----------------------RECV DONE-----------------------------------*/   
	   }
     
         }//     
     
     }//   (if-else)
  } //         
tvalidate(*outM);
}
		 


tfun void tmain1 (tout int * res)
{
 tval struct Pointer pointer;
 struct Pointer results;
 tval struct Answer x;
 tval double z;
#ifdef PRINT 
 tval int res1;
#endif
#ifdef PRINT1
 tval int res2;
#endif 
#ifdef PRINT2
 tval int res3;
#endif
 tval int gauss_res, nev_res;

 struct Arr_List array;
 int i;

 // 
 TCALL(init(&pointer),(0,GR_CI_SYSTEM | GR_CI_FIXED));
#ifdef PRINT
 TCALL(pr_all(pointer,&res1),(0,GR_CI_SYSTEM | GR_CI_FIXED));
 (int)res1;
#endif 


 //.
  for (i=0;i<N;i++)
  {
   array.arr[i]=tnew(struct List);
   results.matr[i]=tnew(struct Matrix);
   tbind(*array.arr[i]);
  } 


 // 
  for (i=0;i<N;i++)
   TCALL(count(i,pointer.matr[i],array,array.arr[i],/* &(res_.r[i]), */results.matr[i] ),(i%tsize,GR_CI_FIXED));

 // 
  for (i=0;i<N;i++)
   tptrwait(results.matr[i]);

#ifdef PRINT1
 tmesg("\n------------------------------Matrix-----------------\n\n");
 TCALL(pr_all(results,&res2),(0,GR_CI_SYSTEM | GR_CI_FIXED));
  (int)res2;
#endif

 gauss(results,SIZE,&x,&gauss_res);
  if (gauss_res!=0)
   {
    tmesg("\n\n  \n");
    *res=1;
    return;
   }
#ifdef PRINT2   
 TCALL(pr_ans(x,&res3),(0,GR_CI_SYSTEM | GR_CI_FIXED));
 (int)res3;
#endif 
 
 nev(pointer,SIZE,x,&z);
 TCALL(pr_nev(z,&nev_res),(0,GR_CI_SYSTEM | GR_CI_FIXED));
  (int)nev_res;
 
 *res=1; 
}


int tmain (int argc, char * argv[])
{
 tval int res;
 tmain1(&res);
 (int)res;
 return 0;
}  
