# 4 "vr.tc"
system-include <tc.h>

system-include <stdio.h>
system-include <stdlib.h>
system-include <math.h>
# 1 "vr.h" 1
# 10 "vr.tc" 2
# 24 "vr.tc"
struct Matrix
 {
  double val[((2000 +1)*(2000/1 +(2000%1?1:0)))];
 };


struct String
 {
  double str[2000 +1];
 };


struct Answer
 {
  double str[2000];
 };


struct List
 {
  struct String tptr string;
  struct List tptr next;
 };


struct Pointer
 {
  struct Matrix tptr matr[1];
 };


struct Arr_List
 {
  struct List tptr arr[1];
 };


double get_fun(int i, int j)
{

 return fabs(i-j);
}
# 102 "vr.tc"
tfun void init(tout struct Pointer * pointer)
{
 int i,j;
 int block, str;

 for (i=0;i<1;i++)
  pointer->matr[i]=tnew(struct Matrix);

 for (i=0;i<2000;i++)
   {
    block=i%1;
    str=i/1;
    pointer->matr[block]->val[str*(2000 +1)+2000]=0;
     for (j=0;j<2000;j++)
      {
       pointer->matr[block]->val[str*(2000 +1)+j]=get_fun(i,j);
       pointer->matr[block]->val[str*(2000 +1)+2000]+=(j%2?0:1)*get_fun(i,j);
      }
   }

 for (i=0;i<1;i++)
  tvalidate(*pointer->matr[i]);

 tvalidate (*pointer);

}


tfun void pr_nev(double z,tout int * res)
{
 printf(" = %le\n",z);
 *res=1;
}



tfun void pr_ans(struct Answer x, tout int * res)
{
 int i;
 printf("\n-----------------------------Answer-------------------\n");

  for (i=0;i<2000;i++)
   printf("%lf  ",x.str[i]);
 printf("\n");
 *res=1;
}



tfun void pr_all(struct Pointer pointer, tout int * res)
{
 int i,j;
 int block, str;

 printf("\n--------------------------------\n");

 for (i=0;i<2000;i++)
   {
    block=i%1;
    str=i/1;
     for (j=0;j<2000;j++)
       printf("%le  ",pointer.matr[block]->val[str*(2000 +1)+j]);
    printf("|  %le  \n",pointer.matr[block]->val[str*(2000 +1)+2000]);
   }

 *res=1;
}


void calculate(double *m, int size, int p, int rank,int col,int first, int last)
{
 int line,i;
 double a,b,r,ycol,yline;

   for (line=first+1;line<last;line++)
   {


     {
       r=sqrt(m[first*(size+1)+col]*
              m[first*(size+1)+col]+
              m[line*(size+1)+col]*
              m[line*(size+1)+col]);
        if (r<=1e-17)
         {
          b=0; a=1;
         }
        else
         {
          a=m[first*(size+1)+col]/r;
          b=-m[line*(size+1)+col]/r;
         }
     }


     for (i=col;i<size+1;i++)
      {
       ycol=m[first*(size+1)+i]*a-
       m[line*(size+1)+i]*b;
       yline=m[first*(size+1)+i]*b+
       m[line*(size+1)+i]*a;

       m[first*(size+1)+i]=ycol;
       m[line*(size+1)+i]=yline;
      }
    }
}


void do_string(double * s1, double * s2, int size, int col)
{
 int j;
 double a,b,r,ycol,yline;
 r = sqrt (s1[col]*s1[col]+s2[col]*s2[col]);
  if (r<=1e-17)
    {
     b=0; a=1;
    }
  else
    {
     a=s1[col]/r;
     b=-s2[col]/r;
    }
  for (j=col;j<size;j++)
   {
    ycol=s1[j]*a-s2[j]*b;
    yline=s1[j]*b+s2[j]*a;

    s1[j]=ycol;
    s2[j]=yline;
   }
}


tfun void gauss(struct Pointer results,int size,tout struct Answer * x_, tout int *res)
{
 int i,j;
 double x[size];
  for (i=size-1;i>=0;i--)
   {
    x[i]=results.matr[i%1]->val[(i/1)*(size+1)+size];
     for (j=i+1;j<size;j++)
      x[i]-=x[j]*results.matr[i%1]->val[(i/1)*(size+1)+j];
     if (fabs(results.matr[i%1]->val[(i/1)*(size+1)+i])<=1e-17)
      {
       *res=10;
       return;
      }
    x[i]/=results.matr[i%1]->val[(i/1)*(size+1)+i];
   }

   *res=0;

 for (i=0;i<size;i++)
  x_->str[i]=x[i];
 tvalidate(*x_);

}

tfun void nev(struct Pointer pointer, int size, struct Answer x_, tout double *z_)
{
 int i,j;
 double y;
 double z=0;
  for (i=0;i<size;i++)
   {
    y=-pointer.matr[i%1]->val[(i/1)*(size+1)+size];
     for (j=0;j<size;j++)
      y+=pointer.matr[i%1]->val[(i/1)*(size+1)+j]*(x_.str[j]);
    z+=fabs(y);
   }
 *z_=z;
}




tfun void count (int rank_,struct Matrix tptr m_, struct Arr_List _array, tout struct List * _list, tout struct Matrix * outM)


{
 struct Arr_List array;
 struct List tptr list = _list;
 struct List tptr next;
 int i,j,k;
 double * value;
 int first, last;
 double * m;
 int arbitr;
 int rank=rank_;

  for (i=0;i<((2000 +1)*(2000/1 +(2000%1?1:0)));i++)
     outM->val[i]=m_->val[i];

  for (i=0;i<1;i++)
   array.arr[i]=_array.arr[i];






 m=(double*)(outM->val);


 last=(2000/1 +(2000%1>rank ? 1:0));
  for (i=0;i<2000 -1;i++)
   {
    first=(i/1 +(i%1>rank ? 1:0));

    calculate(m,2000,1,rank,i,first,last);

    if (first==last)
     {
      tvalidate(*outM);
      return;
     }

    arbitr=i%1;

     if (arbitr==rank)
      {

       for (j=0;j<1;j++)
        {
          if (j==arbitr) continue;
          if ((i/1 +(i%1>j ? 1:0))==(2000/1 +(2000%1>j ? 1:0))) continue;

              list->string=tnew(struct String);
                for(k=i;k<=2000;k++)
                 list->string->str[k]=m[first*(2000 +1)+k];



               tvalidate(* (list->string) );
              list->next=tnew(struct List);
              tbind(*(list->next));
              next=list->next;
              tvalidate(*list);
              list=next;
# 350 "vr.tc"
              next=mkconst(array.arr[j])->next;
              (double)mkconst(array.arr[j])->string->str[0];
              value=(double*)mkconst(array.arr[j])->string->str;



              do_string(m+first*(2000 +1),value,2000 +1,i);
              array.arr[j]=next;






         }


    }
    else
     {



              list->string=tnew(struct String);
                for(k=i;k<=2000;k++)
                 list->string->str[k]=m[first*(2000 +1)+k];




               tvalidate(* (list->string) );
              list->next=tnew(struct List);
              tbind(*(list->next));
              next=list->next;
              tvalidate(*list);
              list=next;







       for (j=0;j<1;j++)
        {
          if (j==rank) continue;
          if ((i/1 +(i%1>j ? 1:0))==(2000/1 +(2000%1>j ? 1:0))) continue;

          if ((j!=arbitr)&&(j!=rank))
          {


              next=mkconst(array.arr[j])->next;
              array.arr[j]=next;







              next=mkconst(array.arr[arbitr])->next;
              array.arr[arbitr]=next;





           }

           else
           {


              next=mkconst(array.arr[arbitr])->next;
              (double)mkconst(array.arr[arbitr])->string->str[0];
              value=(double*)mkconst(array.arr[arbitr])->string->str;



              do_string(value,m+first*(2000 +1),2000 +1,i);

              array.arr[arbitr]=next;





           }

         }

     }
  }
tvalidate(*outM);
}



tfun void tmain1 (tout int * res)
{
 tval struct Pointer pointer;
 struct Pointer results;
 tval struct Answer x;
 tval double z;
# 464 "vr.tc"
 tval int gauss_res, nev_res;

 struct Arr_List array;
 int i;


 TCALL(init(&pointer),(0,GR_CI_SYSTEM | GR_CI_FIXED));







  for (i=0;i<1;i++)
  {
   array.arr[i]=tnew(struct List);
   results.matr[i]=tnew(struct Matrix);
   tbind(*array.arr[i]);
  }



  for (i=0;i<1;i++)
   TCALL(count(i,pointer.matr[i],array,array.arr[i], results.matr[i] ),(i%tsize,GR_CI_FIXED));


  for (i=0;i<1;i++)
   tptrwait(results.matr[i]);







 gauss(results,2000,&x,&gauss_res);
  if (gauss_res!=0)
   {
    tmesg("\n\n  \n");
    *res=1;
    return;
   }





 nev(pointer,2000,x,&z);
 TCALL(pr_nev(z,&nev_res),(0,GR_CI_SYSTEM | GR_CI_FIXED));
  (int)nev_res;

 *res=1;
}


int tmain (int argc, char * argv[])
{
 tval int res;
 tmain1(&res);
 (int)res;
 return 0;
}
