#ifndef PARAMS_H
#define PARAMS_H

#define BOARDSZ (3)

#define FILE_NAME_SIZE 25

/* length of history in file */
#define START_LEVEL 10
/* t-function level */
#define MAX_LEVEL (2)
/* maximum level depth */
#define MAX_DEPTH (100)
/* cut-off level */
#define CUT_LEVEL (100)
/* number of sons after cut off */
#define CUT_NUM (1) 
/* number of bits in word = log(MAX_MOVE)*/
#define BITS_IN_MOVE (4) 
/* number of bits in word = sizeof(int)*8 */
#define BITS_IN_WORD (32)
/* number of moves encoded in a word */
#define MOVES_IN_WORD ((int)(BITS_IN_WORD/BITS_IN_MOVE))

#endif
