#ifndef _FRACTAL_H_
#define _FRACTAL_H_

#include "output.h" // for structs pixel & rect

#ifdef __cplusplus
extern "C" {
#endif

struct params {
	int xoffs;
	int yoffs;
	double scale;
	double re;
	double im;
};

struct pixel render (int x, int y, struct params *par);
int make_params (struct params *par, struct rect r, double tm);

#ifdef __cplusplus
};
#endif

#endif
