
          /* nk1.cpp */ 


#include "cav.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
//#include <conio.h>
//#include <iostream.h>
 
          
  extern unsigned M,N,mn1,MN,MN1,N1;
  extern double   *r,*dr,*z,*dz;
  extern double   alf,sn,cn,ctg,L;
	  
  extern int T; 	 
		 
		 			  

void nk1()
{
	 
    double dr1,dr2,dz1,dz2,q,q0,a,b,c;
	  
  unsigned i,j;
     /**************************
  FILE *out;
  /*******************************************************************************/
  		     
	r(0)=0.0;       z(0)=-ctg;
	 dr1=1.0/(N-6);  dr2=dr1/4.0;
	 dz1=dr1*ctg;    dz2=dz1/4.0;

	 for(i=0;i<4;i++)       {dr(i)=dr2; dz(i)=dz2;}
	 for(i=4;i<(N-4); i++)  {dr(i)=dr1; dz(i)=dz1;}
	 for(i=(N-4);i<N; i++)  {dr(i)=dr2; dz(i)=dz2;}

	  for(i=0;i<N;i++) { r(i+1)=r(i)+dr(i);
	                    z(i+1)=z(i)+dz(i);
	  }
	 q=1.1; q0=0.0; dr2/=T; dz2/=T;
	 while(fabs(q-q0)>1.0e-10){
		 q0=q;
		  q=pow(1.0+L*(q0-1.0)/dz2,1.0/M);
	 }
	   dz(N)=dz2;

	   if(alf<90.0) {
		   b=L/ctg+1.0;
		   a=b*L*L/(b-1.0);
		   for(i=N;i<MN;i++) {
			   j=i+1;
			z(j)=z(i)+dz(i);
		       c=z(j)-L;
            r(j)=sqrt(b*(1.0-c*c/a));
		   dr(i)=r(j)-r(i);
		   dz(j)=dz(i)*q;
		   }
	   }
	   else for(i=N;i<MN;i++) {
		   j=i+1;
        z(j)=z(i)+dz(i);
		r(j)=1.0+sqrt(z(j)*(2.0*L-z(j)));
	   dr(i)=r(j)-r(i);
	   dz(j)=dz(i)*q;
	   }	
  /******************************************************************************
	   out=fopen("nak1.dat","w");
	   for(i=0;i<MN1;i++)
		   fprintf(out,"%lf %lf\n",r(i),z(i));
	   fclose(out);
	   /*************************/

}


        
