#ifndef __TFUN_STRUCTS__
#define __TFUN_STRUCTS__

#define MAX_MN 100
#define MPI_SIZE 20


typedef struct _RetData {
	double b[MAX_MN/MPI_SIZE+1];
 	double r[MAX_MN/MPI_SIZE+1];
	double z[MAX_MN/MPI_SIZE+1];
	double dr[MAX_MN/MPI_SIZE+1];
	double dz[MAX_MN/MPI_SIZE+1];
	double a[(MAX_MN/MPI_SIZE+1)*MAX_MN];
} RetData;

typedef struct _UpdateData {
	double ka[MAX_MN];
	double kb[MAX_MN];
	double kc[MAX_MN];
	double r[MAX_MN];
	double dr[MAX_MN];
	double z[MAX_MN];
	double dz[MAX_MN];
	double s5[MAX_MN];
	double ds[MAX_MN];
	double w0[MAX_MN];
	double w1[MAX_MN];
	double w2[MAX_MN];
	double w11[MAX_MN];
	double e0[MAX_MN];
	double e1[MAX_MN];
	double s[MAX_MN];
	int K;
} UpdateData;


#endif

