/* 
 *   WWBody
 */


/* 
 * 	   
 * choice:
 * 	0 =   
 * 	1 =   
 * NP -     .   
 * ,        , 
 * .
 * numl -         ,   
 *    
 * WWWFieldT -  " ",    
 *          
 */  
  
 // 	nc = number of chains
 
#ifndef __WWBodyTdef___
#define __WWBodyTdef___

#include "windpoint.h"

template <int __choice_,int __NP_,int __nums_,class WWWFieldT> class WWBodyT
    {

	public:

	/*      */		    
	Wind	awnd[__NP_+__choice_];

	Wind	afwnd[__nums_];

	double 	circ[__NP_+__choice_];


	/*        
	 *   */	
	int 	inds[__nums_];

	/*      */
	Point cpnt[__NP_];
	
	Point center;  // for the central point 
	Vector centerspeed;

	// the moment of inertion & density
	double inertion,rho; 	
    
	double source;
    
	/*         */
	Vector norm[__NP_];
	
	/*      */
	double a[(__NP_+2)*(__NP_+2)];   	
	
	/*       */
	double x[__NP_+2];		
	
	/*     */
	double al;		
	
	/*    */
	double aldt,aldtold;				
	    
	    
		
	/*    */
	int Initialize(double time);
	virtual int UserInit();

	int Update(double time,double ts);

	virtual int CountCenter(double time);
	    
	/*       */   
	virtual int CountPoints();
	    
	/*      */
	virtual int CountWinds();
	    
	/*         */
	virtual int CountNorms();
	    
	/*         */
	virtual int CountFWinds();
	    
	/*     
	 *    " ", ..  
	 *  ,   
	 */ 
	
	
	int BuildSolveEquation(WWWFieldT *wf,double ts);

	int TransferNewInformation(WWWFieldT *wf);
	

	private:
	/*        */ 
	int Gauss(double *a,double *x,int n);
	
	inline int swapcolumns(double*,double*,int*,int,int,int);
	inline int swaplines(double*,double*,int*,int,int,int);

	int printmatrix(double*,int); 

    };

#endif
