#ifndef __consts__
#define __consts__

#define SOURCE	0
#define NO_SOURCE 1

#define NUMS 4
//The number of T-functions.
#define R 8

#define MAX(a,b) (a>b?(a):(b))


#define TIME_START 0.0
#define TIME_END 75.
#define TIME_STEP 0.1

#define NP   80
#define MAX_R  (NUMS*((int)((TIME_END-TIME_START)/(TIME_STEP))+2))

//define VISION in oder to use the visualization
#ifndef VISION
#define VISION
#endif
//#undef VISION

//For speed
#define EPS 0.05

#endif
