#ifndef PI
#define PI 3.14159265
#endif

#define FOG
#define FOG_D 0.1

#define MESA_BUGGED

#define ACC 48

#define DIST 30

/* new                            */
#define WIN_SIZE 200
//#define WIN_SIZE 10
#define NFRAMES 20
//#define NFRAMES 504

/* new                            */
#define drand48() (float)0.7386//random number in [0.0, 1.0)
/* end of new                      */

#define VERTEX(I,J) glNormal3fv(normal[I][J]); glVertex3fv(strips[I][J]);

#ifndef M_PI
#define M_PI 3.1415926535
#endif

typedef struct {
  int data[WIN_SIZE*2][WIN_SIZE*2];
  float speed;
  float plaatje;
  float angle2;
  float angle3;
} myframe;

typedef struct {
  myframe* ptr[NFRAMES];
} myframes;
/* end of new                      */

typedef struct
{
    double value;
    double speed;
    int steps;
} Parameter;

#define TOT 4247
#define MAX 10000

void calculate_rc(void);
float calc_speed(float prevspeed, float prevplaatje, int nframe);
float calc_plaatje(float speed, float prevplaatje);
void calc_frame(int nframe, myframe *res);
//void myinit_data(int sz);
void myinit_data();

void display(void);
void Animate(void);
