#ifndef _RT_H_
#define _RT_H_

#include "output.h" // for structs pixel & rect

#include "geometry.h"

#ifdef __cplusplus
extern "C" {
#endif

struct scene;
	
struct params {
	double 		f_ulx;
	double 		f_uly;
	double 		f_stepx;
	double 		f_stepy;
	struct scene	sc;
};

struct pixel render (int x, int y, struct params *par);
int make_params (struct params *par, struct rect r, double tm);
int parse_cmdline (int, int, char**);

#ifdef __cplusplus
};
#endif

#endif
