/* mary */

#ifndef GRAPH_OPS_H
#define GRAPH_OPS_H

#include <dotneato.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

void
layout_graph(Agraph_t *g);

Agraph_t *
create_graph(char *name);

Agnode_t *
insert_node(Agraph_t *g, char *name, int do_layout);

Agedge_t *
insert_edge(Agraph_t *g, char *tail, char *head, char *name, int do_layout);

void
delete_node(Agraph_t *g, char *name, int do_layout);

void
delete_edge(Agraph_t *g, char *tail, char *head, int do_layout);

void
set_node_attr(Agraph_t *g, char *name, char *label, char *style, char *fillcolor);

#ifdef __cplusplus
	   }
#endif /* __cplusplus */

#endif /* GRAPH_OPS_H */
/* end of mary */
