struct List {
	int data;
	tptr List next;
};

TFUNDEF(int, producer_consumer, (int id, int n , ts::TFrz < List > head_in , ts::TObj < List >& head_out), /*static*/, int id ; int n ; ts::TPtr < List > head_in ;, _tf->id = id ; _tf->n = n ; _tf->head_in = head_in ; ts::TFrz< List > __head_out(_tf->head_out) ;, ts::TOut < List > head_out ;, head_out = __head_out() ;, 0)	 
TFUNIMPL(int, producer_consumer, (int id, int n , ts::TFrz < List > head_in , ts::TObj < List >& head_out), /*static*/, int id; int n ; ts::TPtr < List > head_in ;, _tf->id = id ; _tf->n = n ; _tf->head_in = head_in ; ts::TFrz< List > __head_out(_tf->head_out) ;, ts::TOut < List > head_out ;, head_out = __head_out() ;, 0)	
{
	printf("Inside id = %d\n", id);
	tptr List ptr_out = &head_out;
	tptr List ptr_in = head_in;
	while (n > 0) {
		// Producing next list item
		tptr List temp;
		ptr_out->next = new ts::TObj<List>;
		temp = ptr_out->next;
		ptr_out->data = n;
		tdrop(ptr_out);
		ptr_out = temp;
		printf("[%d] Produced %d id = %d\n", ts::myRank, n, id);
		n--;
		// Consuming next list item	
		printf("[%d] Consumed %d id = %d\n", ts::myRank, ptr_in->data, id);
		ptr_in = ptr_in->next;
		if (n > 0) ts::sleep(0.2); // (2)
	}
	ptr_out->next = NULL;
	ptr_out->data = n;
	tdrop(ptr_out);

	return 1;
}

tfun int main(int argc, char** argv)
{
	int n = 5;
	if (argc > 1) {
		n = atoi(argv[1]);
	}
	
	tval int a1,a2;
	tptr List head1 = new ts::TObj<List>;
	tptr List head2 = new ts::TObj<List>;
	{
		tct(atRank(ts::realsuperSize-1));
		a1 = producer_consumer(0,n,head1,*head2);
	        tct(atRank(0));
		a2 = producer_consumer(1,n,head2,*head1);
		tdrop(head2);
		tdrop(head1);
	}
	(int)a1;
	(int)a2;
	return 0;
}

