// list generation

typedef struct LIST
{
    int x;
    /*tval*/ int y;
    tptr struct LIST next;
} list;

tfun int vvv (int n)
{
	fprintf(stderr,"[%d] vvv(%d)\n", ts::myRank, n);
	return n*10001;
}

tfun list list_tail (int n)
{
	list v;
	v.x = n;
	v.y = vvv(0);
	v.next = NULL;
	return v;
}

tfun int producer_loop (int n, tout list output)
{
	int i;
	tptr list p;

	p = &output;

	for (i = 1; i <= n; i++) {
		list tmp;
		tval list z;

		fprintf(stderr, "[%d] produce_loop %d\n",ts::myRank, i);
		
		tmp.x = i;
		tmp.y = vvv(i);
		if (i == n) z = list_tail (-100);
		tmp.next = &z;

		*p = tmp;
		tdrop(p);
		p = tmp.next;
	}
	
	return 0;
}

// FIXME tptr list
tfun list producer (int n, int m)
{
    list res;
    
    fprintf(stderr, "[%d] produce %d\n",ts::myRank, n);
    res.x = n;
    res.y = vvv(-n);
    
    if (n > 0) {
      if (n>1) {
	      tval list next;
	      next = producer(n-1, m);
	      res.next = &next;
      } else if (m) {
	      tval list next;
	      producer_loop(m, next);
	      res.next = &next;
      } else res.next = NULL;
    } else
    if (n == 0) {
      // Let's do the right thing here.
      // We shouldn't generate -1'th item
      res.next = NULL;
    }
    //sleep (1);
    fprintf(stderr, "%d ready\n",n);
   
    return res;
}

tfun int consumer(list x)
{
    tval list g = x;
    // HACK! We can't write "cur = &x" here, because type of "&x" is "list*"
    tptr list cur = &g;
    list *l;
    
    while ((l = cur) != NULL) {
	fprintf(stderr, "consume %d\n", l->x);
	fprintf(stderr, "y=%d\n", (int)(l->y));
	cur = l->next;
	fprintf(stderr, "got next\n");
    }

    return 1;
}

int test(int n, int m)
{
    fprintf(stderr, "\nTEST %d,%d\n",n,m);
    return consumer(producer(n,m));
}

tfun int main(int argc,char *argv[])
{
    if (argc < 3) return 1;
    test(atoi(argv[1]),atoi(argv[2]));
    return 0;
}
