#include <stdio.h>

#define NUM 10
#define SIZE 1000000

typedef struct args {
	double value[SIZE];
} Large_Struct_Args;

tfun int Make_Work(Large_Struct_Args& args,int id)
{
	int i;
	double sum=0;
	Large_Struct_Args *ptr1;
	
	printf("In Make_Work : id = %d node = %d\n",id,ts::myRank); 
	ptr1=&args;
	printf("Got ptr\n");
	for (i=0;i<SIZE;i++) sum+=ptr1->value[i];
	return 1;
}
	
tfun int main(int argc,char *argv[])
{
	tval int dummy[NUM];
	int i,j;
	double sum=0.;
	Large_Struct_Args *args=new Large_Struct_Args;

	printf("Start\n");
	for (j=0;j<SIZE;j++) args->value[j]=j;
		
	printf("End of init\n");

	for (i=0;i<NUM;i++) {
		tct(atRank(i % ts::realsuperSize));
		dummy[i]=Make_Work(*args,i);
	}
	
	printf("Work started\n");	

	for (i=0;i<NUM;i++) {
		sum+=dummy[i];
	}
	printf("Work done\n");
	printf("Result : %lf\n",sum);
	return 0;
}
