confArgs() {
    dir="$1"
    shift
    case "$dir" in 
	pth) 
	    echo -n '--with-mctx-mth=mcsc  --with-mctx-dsp=sjlj   --with-mctx-stk=mc '  
#	    echo -n '--with-mctx-mth=sjlj  --with-mctx-dsp=usjlj  --with-mctx-stk=sas ' 
	    ;;
	opencxx)
	    echo -n '--disable-gc --disable-static'
	    ;;
	dmpi)
	    echo -n "$@ "
	    echo -n "--lam-root=/usr --scali-root=/opt/scali --mpich-root=/opt/mpich-*  "
	    echo -n "--mpich-g2-root=/opt/mpich-g2-* --mp-mpich-root=/opt/mp-mpich-* "
	    echo -n "--without-default"  # FIXME
	    ;;
    esac
}
  
configureRecursive() {
    for dir in * ; do 
	[ ! -x "$dir/configure" ] || \
	    (cd "$dir"
	    args=`confArgs $dir $@`
	    echo 
	    echo "Configuring $dir with $args"
	    ./configure $args)
    done
}
