# 10 "tlife.tc"
system-include <tc.h>

const int NN = 10000;
const int nn = 50;
const int hh = 15;
const int mm = 50;
const int col = 4;

struct field
{
 int a[nn*mm];
};

struct line
{
 int a[nn];
 struct line tptr next;
};

typedef struct field tfd;
typedef struct line tln;

struct ar_field
{
 tptr tfd item;
};

struct ar_line
{
 tptr tln item;
};

struct sres
{
 tval int res;
};

tfun void work(int n, tfd tptr ar, tln tptr in1, tln tptr in2, tout tln *out1, tout tln *out2, tout int *_res)
{
 int *Field1, *Field2;
 int *src, *dst, *t;
 int i, j, k;
 int sum, x, y;

 tln tptr curin1;
 tln tptr curin2;
 tln tptr curout1;
 tln tptr curout2;
 tln tptr tmp1;

 Field1 = (int*)talloc(sizeof(int)*nn*mm);
 Field2 = (int*)talloc(sizeof(int)*nn*mm);

 for(i=0;i<mm;i++)
  for(j=0;j<nn;j++)
   Field1[i*nn+j] = ((tfd)*ar).a[i*nn+j];

 curin1 = in1;
 curin2 = in2;
 curout1 = out1;
 curout2 = out2;

 src = Field1;
 dst = Field2;
# 84 "tlife.tc"
 for(k=0;k<NN;k++)
 {


  tptrwait(curin1);
  sum = mkconst(curin1)->a[nn-1] + src[nn-1] + src[2*nn-1] +
        mkconst(curin1)->a[0] + src[nn] +
        mkconst(curin1)->a[1] + src[1] + src[nn+1];
  if(sum==2)
   dst[0] = src[0];
  else
   if(sum==3)
    dst[0] = 1;
   else
    dst[0] = 0;
  for(i=1;i<nn;i++)
  {
   x = (nn+i-2)%nn;
   y = (i + 1)%nn;
   sum = sum - mkconst(curin1)->a[x] - src[x] - src[nn + x] - src[i] +
         src[i-1] + mkconst(curin1)->a[y] + src[y] + src[nn+y];
   if(sum==2)
    dst[i] = src[i];
   else
    if(sum==3)
     dst[i] = 1;
    else
     dst[i] = 0;
  };



  for(i=0;i<nn;i++)
   curout2->a[i] = dst[i];
  curout2->next = tnew(tln);
  __bind(*(curout2->next),*curout2);
  tmp1 = curout2;
  curout2 = curout2->next;
  tvalidate(*tmp1);



  tptrwait(curin2);
  sum = mkconst(curin2)->a[nn-1] + src[mm*nn-1] + src[(mm-1)*nn-1] +
        mkconst(curin2)->a[0] + src[(mm-2)*nn] +
        mkconst(curin2)->a[1] + src[(mm-1)*nn+1] + src[(mm-2)*nn+1];
  if(sum==2)
   dst[(mm-1)*nn] = src[(mm-1)*nn];
  else
   if(sum==3)
    dst[(mm-1)*nn] = 1;
   else
    dst[(mm-1)*nn] = 0;
  for(i=1;i<nn;i++)
  {
   x = (nn+i-2)%nn;
   y = (i + 1)%nn;
   sum = sum - mkconst(curin2)->a[x] - src[(mm-1)*nn+x] - src[(mm-2)*nn+x] -
         src[(mm-1)*nn+i] + src[(mm-1)*nn+i-1] + mkconst(curin2)->a[y] +
         src[(mm-1)*nn+y] + src[(mm-2)*nn+y];
   if(sum==2)
    dst[(mm-1)*nn+i] = src[(mm-1)*nn+i];
   else
    if(sum==3)
     dst[(mm-1)*nn+i] = 1;
    else
     dst[(mm-1)*nn+i] = 0;
  };



  for(i=0;i<nn;i++)
   curout1->a[i] = dst[(mm-1)*nn+i];
  curout1->next = tnew(tln);
  __bind(*(curout1->next),*curout1);
  tmp1 = curout1;
  curout1 = curout1->next;
  tvalidate(*tmp1);



  for(j=1;j<mm-1;j++)
  {
  sum = src[j*nn-1] + src[(j+1)*nn-1] + src[(j+2)*nn-1] +
        src[(j-1)*nn] + src[(j+1)*nn] +
        src[(j-1)*nn+1] + src[j*nn+1] + src[(j+1)*nn+1];
  if(sum==2)
   dst[j*nn] = src[j*nn];
  else
   if(sum==3)
    dst[j*nn] = 1;
   else
    dst[j*nn] = 0;
  for(i=1;i<nn;i++)
  {
   x = (nn+i-2)%nn;
   y = (i + 1)%nn;
   sum = sum - src[(j-1)*nn+x] - src[j*nn+x] - src[(j+1)*nn+x] -
         src[j*nn+i] + src[j*nn+i-1] + src[(j-1)*nn+y] +
         src[j*nn+y] + src[(j+1)*nn+y];
   if(sum==2)
    dst[j*nn+i] = src[j*nn+i];
   else
    if(sum==3)
     dst[j*nn+i] = 1;
    else
     dst[j*nn+i] = 0;
  };
  };
# 204 "tlife.tc"
  t = src;
  src = dst;
  dst = t;

  curin1 = mkconst(curin1)->next;
  curin2 = mkconst(curin2)->next;

 };

 *_res = 1;
}

int tmain(int argc, char* argv[])
{
 struct ar_field A[col];
 struct ar_line uplines[col], downlines[col];
 struct sres res[col];
 int res0;
 int i,j,k;


 for(i=0;i<col;i++)
  A[i].item = tnew(tfd);






 A[1].item->a[1] = 1;
 A[1].item->a[2] = 1;
 A[1].item->a[3] = 1;
 A[1].item->a[21] = 1;
 A[1].item->a[22] = 1;
 A[1].item->a[23] = 1;

 for(i=0;i<col;i++)
 {
  uplines[i].item = tnew(tln);
  uplines[i].item->next = tnew(tln);
  downlines[i].item = tnew(tln);
  downlines[i].item->next = tnew(tln);
 };
 for(i=0;i<nn;i++)
 {
  uplines[0].item->a[i] = A[col-1].item->a[(mm-1)*nn+i];
  downlines[col-1].item->a[i] = A[0].item->a[i];
 };
 for(i=1;i<col;i++)
  for(j=0;j<nn;j++)
  {
   uplines[i].item->a[j] = A[i-1].item->a[(mm-1)*nn+j];
   downlines[i-1].item->a[j] = A[i].item->a[j];
  };

 for(k=0;k<col;k++)
  tvalidate(*A[k].item);

 for(i=0;i<col;i++)
 {
  tvalidate(*uplines[i].item);
  tvalidate(*downlines[i].item);
 };



  work(1, A[0].item, uplines[0].item, downlines[0].item,
      ((tln)*uplines[1].item).next, ((tln)*downlines[col-1].item).next, &(res[0].res));


 for(k=1;k<col-1;k++)
  work(k+1, A[k].item, uplines[k].item, downlines[k].item,
      ((tln)*uplines[k+1].item).next, ((tln)*downlines[k-1].item).next, &(res[k].res));

 work(col, A[col-1].item, uplines[col-1].item, downlines[col-1].item,
      ((tln)*uplines[0].item).next, ((tln)*downlines[col-2].item).next, &(res[col-1].res));
# 299 "tlife.tc"
 for(k=0;k<col;k++)
  res0 = res0 + res[k].res;

 return 0;
}
