// gcc plon45.c -lm -lX11 -L/usr/X11R6/lib -o out

#include<stdlib.h>
#include<stdio.h>
#include<math.h>
#define N 50

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>

Display *xDisplay;
int xScreen;
Window xWindow;
GC xGC;

void ffopen(int n, int tka[N], int tkb[N], FILE *f);
int initwindow();
unsigned long int rgb(int r, int g, int b);
void risunok(void);

void makenormfile(void)
{
   float x,y;
   FILE *f1,*f2;
   int i,j,k,s;
   
   f1=fopen("vz","r");
   f2=fopen("lll","w");
   for(i=0;i<3600;i++) 
   {
      s=0;
      fscanf(f1,"%f",&x);
      x=x*10;
      for(j=-10000;j<10000;j++) 
      {
         if((x>j)&&(x<j+1)) s=j;
      }
      fprintf(f2,"\n %d",s);
      if((i+1)%4==0) fprintf(f2,"\n ");
        
   }
   fclose(f1);
   fclose(f2);
   return;
}
//*****************************************************************************************
int main(void)
{

   makenormfile();
   risunok();
   printf("\n");
   return 0;
}

/* Initializes graphics and sets all parameters; returns 1 if failed */
int initwindow()
{
    XTextProperty prop;
    char * WinName = "New Eldar programm.";

    if ((xDisplay = XOpenDisplay (NULL)) == NULL)
        {
          printf("Cannot open window.\n");
          return 1;
        }
    xScreen = DefaultScreen(xDisplay);
    xWindow = XCreateSimpleWindow(xDisplay, RootWindow(xDisplay, xScreen),
 			          0, 0, 800, 500, 0, 0 , 0);
    XSelectInput(xDisplay, xWindow, ExposureMask | KeyPressMask | ButtonPressMask);
    XMapWindow(xDisplay,xWindow);
    XStringListToTextProperty(&WinName,1,&prop);
    XSetWMName(xDisplay,xWindow,&prop);
    return 0;
}

unsigned long int rgb(int r, int g, int b)
{
   return 256*256*r + 256*g + b;
}

void risunok(void)
{
    FILE *f;
    int key,x,y,i,j,k,m,n,xx[100],yy[100],hh[100],rr[100];
    XEvent Evnt;
    int mmm[30][30];
    int ttt[30][30];
    float t,h;
    char w[10];

    
    f=fopen("vlana","r");
    fscanf(f,"%d",&n);
    for(i=0;i<n;i++)
    {
        fscanf(f,"%d",&xx[i]);
        fscanf(f,"%d",&yy[i]);
        fscanf(f,"%d",&rr[i]);
        fscanf(f,"%d",&hh[i]);   
    }
    fclose(f);

    f=fopen("lll","r");
    for(j=0;j<30;j++)
    for(i=0;i<30;i++)
    {
        mmm[i][j]=0;
        fscanf(f,"%d",&k);
        fscanf(f,"%d",&k);
        fscanf(f,"%d",&mmm[i][j]);
	fscanf(f,"%d",&ttt[i][j]);   
    }
    fclose(f);
  /* Initialize X window */
    if (initwindow()) return;
  //   init_default_settings();
    while (1)
    {
        XNextEvent(xDisplay,&Evnt);
        if (Evnt.type == KeyPress) break;
        xGC = XCreateGC(xDisplay, xWindow, 0, NULL);
        XSetForeground(xDisplay,xGC,rgb(0,0,0));
        
	for(i=0;i<200;i++) XDrawLine(xDisplay, xWindow, xGC, 0,i,500,i);
        XSetForeground(xDisplay,xGC,rgb(0,55,55));
  //  goluboi
        XSetForeground(xDisplay,xGC,rgb(0,0,255));
  //  sinii
        XSetForeground(xDisplay,xGC,rgb(0,100,100));
  // zeleenii

        XDrawLine(xDisplay, xWindow, xGC,200-100,200,200+100,200);
        XDrawLine(xDisplay, xWindow, xGC,200,200-100,200,200+100);

        XDrawLine(xDisplay, xWindow, xGC,500-100,200,500+100,200);
        XDrawLine(xDisplay, xWindow, xGC,500,200-100,500,200+100);

	for(m=0;m<n;m++)
	for(k=0;k<n;k++)
	for(i=0;i<400;i++)
        for(j=0;j<400;j++)

        {
            
            t=sqrt((i-200-xx[k]*10)*(i-200-10*xx[k])+(j-(200-10*yy[k]))*(j-(200-10*yy[k])))-rr[k]*10;
	    if(t<0)
	    {
               h=hh[k]*t/rr[k];
	       if(h<1)
	       {    
	          XSetForeground(xDisplay,xGC,rgb(0,255,0));
                  XDrawLine(xDisplay, xWindow, xGC,i,j,i,j+1);
                  XSetForeground(xDisplay,xGC,rgb(0,255,0));
               }
	       else
	       {	
 	          XSetForeground(xDisplay,xGC,rgb(0,255,0));
                  XDrawLine(xDisplay, xWindow, xGC,i,j,i,j+1);
                  XSetForeground(xDisplay,xGC,rgb(0,255,0));
               }	    
 	    
	    }      
        }
	
	for(m=0;m<n;m++)
	for(k=0;k<n;k++)
	for(i=0;i<400;i++)
        for(j=0;j<400;j++)

        {
            
            t=sqrt((i-200-xx[k]*10)*(i-200-10*xx[k])+(j-(200-10*yy[k]))*(j-(200-10*yy[k])))-rr[k]*10;
	    if(t<0)
	    {
               h=hh[k]*t/rr[k];
	       if(h<1)
	       {    
	          XSetForeground(xDisplay,xGC,rgb(0,255,0));
                  XDrawLine(xDisplay, xWindow, xGC,i+300,j,i+300,j+1);
                  XSetForeground(xDisplay,xGC,rgb(0,255,0));
               }
	       else
	       {	
 	          XSetForeground(xDisplay,xGC,rgb(0,255,0));
                  XDrawLine(xDisplay, xWindow, xGC,i+300,j,i+300,j+1);
                  XSetForeground(xDisplay,xGC,rgb(0,255,0));
               }	    
 	    
	    }      
       
        }


        XSetForeground(xDisplay,xGC,rgb(0,255,0));   //   zeltii
        for(i=0;i<n;i++) XDrawLine(xDisplay, xWindow, xGC,200+xx[i]*10,200-yy[i]*10,200+xx[i]*10+1,200-yy[i]*10+1);	
        XDrawLine(xDisplay, xWindow, xGC,200+5*10,200,200+5*10+1,200+1);	
       
     /*  for(j=0;j<35;j++) 
       {            
          XSetForeground(xDisplay,xGC,rgb(0,0,j));   //   zeltii
          XDrawLine(xDisplay, xWindow, xGC,400,200-j*2,400+50,200-j*2);	      
       }*/    
       
       
       for(j=0;j<30;j++) 
       for(i=0;i<30;i++)
       {
           x=0;   
           for(k=0;k<35;k++)
	   {
	       if((mmm[i][j]>k*20)&&(mmm[i][j]<(k+1)*20)) x=k;
	       
	   }
	   mmm[i][j]=x;
       }          
       
       for(j=0;j<30;j++) 
       for(i=0;i<30;i++)
       {
          XSetForeground(xDisplay,xGC,rgb(0,1,mmm[i][j]));   //   zeltii
  
          for(k=0;k<4;k++) 
	  for(m=0;m<4;m++) 
	  XDrawLine(xDisplay, xWindow, xGC,125+i*5+m,274-j*5+k,125+i*5-m,274-j*5-k);

//          XDrawLine(xDisplay, xWindow, xGC,123+i*5,280-j*5,123+i*5,280-j*5+5);	      
//          XDrawLine(xDisplay, xWindow, xGC,123+i*5,280-j*5,123+i*5+5,280-j*5+5);	      
//          XDrawLine(xDisplay, xWindow, xGC,123+i*5,280-j*5,123+i*5-1,280-j*5+1);	      

       }
        XSetForeground(xDisplay,xGC,rgb(0,255,0));   //   zeltii
        for(i=0;i<n;i++) XDrawLine(xDisplay, xWindow, xGC,200+xx[i]*10,200-yy[i]*10,200+xx[i]*10+1,200-yy[i]*10+1);	
    	XDrawLine(xDisplay, xWindow, xGC,200+5*10,200,200+5*10+1,200+1);	
    
      
      
       for(j=0;j<30;j++) 
       for(i=0;i<30;i++)
       {
          XSetForeground(xDisplay,xGC,rgb(0,mmm[i][j],mmm[i][j]));   //   zeltii
  
          for(k=0;k<5;k++) 
	  for(m=0;m<5;m++) 
	  XDrawLine(xDisplay, xWindow, xGC,325+i*5+m,474-j*5+k,325+i*5-m,474-j*5-k);

       }
        XSetForeground(xDisplay,xGC,rgb(0,255,0));   //   zeltii
        for(i=0;i<n;i++) XDrawLine(xDisplay, xWindow, xGC,400+xx[i]*10,400-yy[i]*10,400+xx[i]*10+1,400-yy[i]*10+1);	

    }
    XFreeGC(xDisplay, xGC);
    XCloseDisplay(xDisplay);
}


