
/* T-wrappers for tfun `Best_Moves' */
struct __Best_Moves_args {
	T_Val<struct History> Hist;
	T_Val<struct position> pos;
	T_Val<int> start_level;
	T_Val<int> send_num;
};
struct __Best_Moves_ress {
	T_Ptr<struct t_stream > output;
};
#define Best_Moves(_Hist,_pos,_output,_start_level,_send_num) { \
	Continuation<__Best_Moves_args, __Best_Moves_ress>* __cont = \
	new Continuation<__Best_Moves_args, __Best_Moves_ress>( \
	  __tfun_Best_Moves, new ComputationStateFactory<FastProcess>, \
	  call_info_default \
	); \
	__cont->args.Hist = (_Hist); \
	__cont->args.pos = (_pos); \
	(*(_output)).bind(__cont); \
	__cont->ress.output = (_output); \
	__cont->args.start_level = (_start_level); \
	__cont->args.send_num = (_send_num); \
	__cont->try_fixed(); \
}


/* T-wrappers for tfun `Read_Input' */
struct __Read_Input_args {
	T_Val<FileName> fname;
};
struct __Read_Input_ress {
	T_Ptr<struct History > res;
	T_Ptr<struct position > pos;
	T_Ptr<int > start_level;
};
#define Read_Input(_res,_pos,_fname,_start_level) { \
	Continuation<__Read_Input_args, __Read_Input_ress>* __cont = \
	new Continuation<__Read_Input_args, __Read_Input_ress>( \
	  __tfun_Read_Input, new ComputationStateFactory<FastProcess>, \
	  call_info_default \
	); \
	(*(_res)).bind(__cont); \
	__cont->ress.res = (_res); \
	(*(_pos)).bind(__cont); \
	__cont->ress.pos = (_pos); \
	__cont->args.fname = (_fname); \
	(*(_start_level)).bind(__cont); \
	__cont->ress.start_level = (_start_level); \
	__cont->try_fixed(); \
}


/* T-wrappers for tfun `Calculate' */
struct __Calculate_args {
	T_Ptr<struct t_stream> output;
};
struct __Calculate_ress {
	T_Ptr<int > out;
};
#define Calculate(_output,_out) { \
	Continuation<__Calculate_args, __Calculate_ress>* __cont = \
	new Continuation<__Calculate_args, __Calculate_ress>( \
	  __tfun_Calculate, new ComputationStateFactory<FastProcess>, \
	  call_info_default \
	); \
	__cont->args.output = (_output); \
	(*(_out)).bind(__cont); \
	__cont->ress.out = (_out); \
	__cont->try_fixed(); \
}

