
/* T-wrappers for tfun `AddResults' */
struct __AddResults_args {
	T_Val<local_data> _old_data;
	T_Val<int> _j;
};
struct __AddResults_ress {
	T_Ptr<int > i;
};
#define AddResults(__old_data,__j,_i) { \
	Continuation<__AddResults_args, __AddResults_ress>* __cont = \
	new Continuation<__AddResults_args, __AddResults_ress>( \
	  __tfun_AddResults, new ComputationStateFactory<FastProcess>, \
	  call_info_default \
	); \
	__cont->args._old_data = (__old_data); \
	__cont->args._j = (__j); \
	(*(_i)).bind(__cont); \
	__cont->ress.i = (_i); \
	__cont->try_fixed(); \
}


/* T-wrappers for tfun `consumer_producer' */
struct __consumer_producer_args {
	T_Val<int> _side;
	T_Val<int> _node_rank;
	T_Ptr<local_data> _src;
	T_Ptr<list> _left_receiver;
	T_Ptr<list> _right_receiver;
};
struct __consumer_producer_ress {
	T_Ptr<list > _left_sender;
	T_Ptr<list > _right_sender;
	T_Ptr<local_data > dummy;
};
#define consumer_producer(__side,__node_rank,__src,__left_receiver,__right_receiver,__left_sender,__right_sender,_dummy) { \
	Continuation<__consumer_producer_args, __consumer_producer_ress>* __cont = \
	new Continuation<__consumer_producer_args, __consumer_producer_ress>( \
	  __tfun_consumer_producer, new ComputationStateFactory<FastProcess>, \
	  call_info_default \
	); \
	__cont->args._side = (__side); \
	__cont->args._node_rank = (__node_rank); \
	__cont->args._src = (__src); \
	__cont->args._left_receiver = (__left_receiver); \
	__cont->args._right_receiver = (__right_receiver); \
	(*(__left_sender)).bind(__cont); \
	__cont->ress._left_sender = (__left_sender); \
	(*(__right_sender)).bind(__cont); \
	__cont->ress._right_sender = (__right_sender); \
	(*(_dummy)).bind(__cont); \
	__cont->ress.dummy = (_dummy); \
	__cont->try_fixed(); \
}


/* T-wrappers for tfun `tmain1' */
struct __tmain1_args {
};
struct __tmain1_ress {
	T_Ptr<int > doom;
};
#define tmain1(_doom) { \
	Continuation<__tmain1_args, __tmain1_ress>* __cont = \
	new Continuation<__tmain1_args, __tmain1_ress>( \
	  __tfun_tmain1, new ComputationStateFactory<FastProcess>, \
	  call_info_default \
	); \
	(*(_doom)).bind(__cont); \
	__cont->ress.doom = (_doom); \
	__cont->try_fixed(); \
}

