//
// Copyright (C) 2000, 2001 GRACE development team  <grace@msu.ru>
//
// GRACE is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// GRACE is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with GRACE; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// $Source: /cvsroot/grace/src/gr_computation_space.hh,v $
// $Revision: 1.6 $
// $Date: 2001/01/30 09:29:35 $

#ifndef __computation_space_hh__
#define __computation_space_hh__

#include "gr_common.hh"

namespace grace
{

typedef uint32_t CompSpaceID ;

//
//! For special computational space IDs high bit is set
#define CSID_SPECIAL 0x80000000 ;

#define GR_TPTR_LOCAL_ID  CompSpaceID(0x80000002)
#define GR_TPTR_REMOTE_ID CompSpaceID(0x80000003)

}

#endif // __computation_space_hh__
