//
// Copyright (C) 2000, 2001 GRACE development team  <grace@msu.ru>
//
// GRACE is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// GRACE is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with GRACE; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// $Source: /cvsroot/grace/src/gr_profile.cc,v $
// $Revision: 1.2 $
// $Date: 2001/08/09 10:25:32 $

#include "gr_core.hh"
#include "gr_profile.hh"

namespace grace
{

ProfTime              ProfBlock::start_time;

volatile ProfBlock* prof_blocks = null;

ProfBlock*&    ProfBlock::get_current_location() 
{
  static ProfBlock dummy_block("__dummy__",0);
  static ProfBlock *dummy_block_ref = &dummy_block;
  return current ? current->prof_block : dummy_block_ref;
}

}

