//
// Copyright (C) 2000, 2001 GRACE development team  <grace@msu.ru>
//
// GRACE is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// GRACE is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with GRACE; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// $Source: /cvsroot/grace/src/gr_shared_pipe.hh,v $
// $Revision: 1.4 $
// $Date: 2002/01/29 17:05:59 $

#ifndef __gr_shared_pipe_hh__
#define __gr_shared_pipe_hh__

#include "gr_common.hh"
#include "gr_shared_allocator.hh"
#include "pxx_pipe.ih"

namespace grace
{

class SharedPipe :
  public pxx::Pipe
{

public:
  //
  //! Constructor
  inline SharedPipe () {}
  //
  //! Constructor
  inline ~SharedPipe () {}
  //
  //! Overloaded operator new
  OVERLOAD_NEW
  //
  //! Overloaded operator delete
  OVERLOAD_DELETE

};

}

#endif // __gr_shared_pipe_hh__

