#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "consts.h"
#include "utils.h"
#include "move.h"

//Смещение свободных вихрей -- функция для распараллеливания


//tfun int calc(int _first,int _last,tptr struct calc_args params,tout struct 
//calc_res result)

TFUNDEF(int, calc, (int _first , int _last , ts::TFrz < struct calc_args > params ,
ts::TObj < struct calc_res >& result), /*static*/, int _first ; int _last ; ts::TPtr
< struct calc_args > params ;, _tf->_first = _first ; _tf->_last = _last ;
_tf->params = params ; ts::TFrz< struct calc_res > __result(_tf->result) ;, ts::TOut
< struct calc_res > result ;, result = __result() ;, 0)
 

TFUNIMPL(int, calc, (int _first , int _last , ts::TFrz < struct calc_args > params ,
ts::TObj < struct calc_res >& result), /*static*/, int _first ; int _last ; ts::TPtr
< struct calc_args > params ;, _tf->_first = _first ; _tf->_last = _last ;
_tf->params = params ; ts::TFrz< struct calc_res > __result(_tf->result) ;, ts::TOut
< struct calc_res > result ;, result = __result() ;, 0)
{
int k,ic,is,ip,ii;				//счетчики
double xold,yold,xf,yf,xp,yp;		//координаты свободных вихрей при пересчете
double ro,roold,rv;			//расстояния
double wx,wy;				//компоненты индуцированной скорости

double *x1,*y1,*ga,*gak,*dg,*xbk,*ybk,*xb,*yb;
double *al,*alold,*xn,*yn;
double q,ta;
int ir,first,last;
struct calc_res *tmp_result;
first=_first,last=_last;

x1=params->x1;y1=params->y1;ga=params->ga;gak=params->gak;
xb=params->xb;yb=params->yb;xbk=params->xbk;ybk=params->ybk;
dg=params->dg;al=params->al;alold=params->alold;
q=params->q;ta=params->ta;ir=params->ir;

tmp_result=(struct calc_res*)malloc(sizeof(struct calc_res));
xn=tmp_result->xn;
yn=tmp_result->yn;

  for (k=0;k<FOUR;k++)
   for (ic=0;ic<NC;ic++) //500
    for (is=first;is<last;is++)		//FIXME : [0...ir]
     {
      ii=is-first; 			//index for results - xn,yn
      		
      xold=x1[F(k,ic,is)];
      yold=y1[F(k,ic,is)];
      
//Вызов подпрограммы вычисления суммарной скорости в точке, где находится 
//данный свободный вихрь
      ospeed(xold,yold,
      		xb,yb,xbk,ybk,x1,y1,ga,gak,dg,ta,ir,q,
      		&wx,&wy);
      //error+=(wx*wx+wy*wy)*dg[F(k,ic,is)];
      xn[F(k,ic,ii)]=xold+DT*wx;
      yn[F(k,ic,ii)]=yold+DT*wy;
      
      //смещение вихрей, попавших в зону безопасности (т.е. в окрестность 
      //цилиндра или пластин), или пересекших одну из пластин 
       for (ip=0;ip<FOUR;ip++) //505
       {
	xf=xn[F(k,ic,ii)];
	yf=yn[F(k,ic,ii)];
	rv=sqrt(xf*xf+yf*yf);
	 if (rv<(R+DZ*DS))
	  {
	   xf*=(R+DZ*DS)/rv;
	   yf*=(R+DZ*DS)/rv;
	   rv=(R+DZ*DS);
	  }
	xp=cos(al[ip])*(xf*cos(al[ip])+yf*sin(al[ip]));
	yp=sin(al[ip])*(xf*cos(al[ip])+yf*sin(al[ip]));
	ro=-xf*sin(al[ip])+yf*cos(al[ip]);
	roold=-xold*sin(alold[ip])+yold*cos(alold[ip]);
	 if (is==ir)
	  roold=ro;
	 if (rv<(R+NK*DS))
	 {
	  if ((fabs(ro)<E0)||(ro*roold<0))
	   {
	    if (roold>=0) 
	     {
	      xn[F(k,ic,ii)]=xp-E0*sin(al[ip]);
	      yn[F(k,ic,ii)]=yp+E0*cos(al[ip]);
	     }
	    else
	     {
	      xn[F(k,ic,ii)]=xp+E0*sin(al[ip]);
	      yn[F(k,ic,ii)]=yp-E0*cos(al[ip]);
	     }
	    }
	  }    
	 }//505
//Смещение от цилиндра
      rv=sqrt(xn[F(k,ic,ii)]*xn[F(k,ic,ii)]+
      	yn[F(k,ic,ii)]*yn[F(k,ic,ii)]);
       if (rv<R+DZ*DS)
       {
        xn[F(k,ic,ii)]*=(R+DZ*DS)/rv;
        yn[F(k,ic,ii)]*=(R+DZ*DS)/rv;
//#ifdef SAVE
//	fprintf(f7,"%lf %lf %lf\n",xn[F(k,ic,is)],yn[F(k,ic,is)],rv);
//#endif	        
        rv=(R+DZ*DS);
        }
     }//500
     
     result=*tmp_result;
     ::free(tmp_result);
     return 0;
}

void move(double *x1, double *y1, double *al, double *alold,double *xb, double *yb,
	double *xbk, double *ybk, double *ga, double *gak, double *dg,
	double q, int ir, double ta//, double* xn, double* yn
#ifdef SAVE
,FILE *f7
#endif
	)        
{
        int i;   
        int first,last;
        tptr struct calc_res all_res[TFUN_NUM];
	tptr struct calc_args args=new ts::TObj<struct calc_args>;
        tval int dummy[TFUN_NUM];
        
        for (i=0;i<TFUN_NUM;i++) all_res[i]=new ts::TObj<struct calc_res>;
        
        memcpy(args->x1,x1,FOUR*IR_MAX*NC*sizeof(double));
        memcpy(args->y1,y1,FOUR*IR_MAX*NC*sizeof(double));
        memcpy(args->dg,dg,FOUR*IR_MAX*NC*sizeof(double));
        memcpy(args->ga,ga,N*sizeof(double));
        memcpy(args->xb,xb,N*sizeof(double));
        memcpy(args->yb,yb,N*sizeof(double));
	memcpy(args->gak,gak,FOUR*NK*sizeof(double));
        memcpy(args->xbk,xbk,FOUR*NK*sizeof(double));
        memcpy(args->ybk,ybk,FOUR*NK*sizeof(double));
        memcpy(args->al,al,FOUR*sizeof(double));
	memcpy(args->alold,alold,FOUR*sizeof(double));
        args->q=q;args->ta=ta;
        args->ir=ir;
             
   	temp=MPI_Wtime()-temp;
        t2+=temp;       
      	temp=MPI_Wtime();
        
        for (i=0;i<TFUN_NUM;i++) {
        	first=i*(ir+1);			//FIXME : possible bug?
                first/=TFUN_NUM;
                last=(i+1)*(ir+1);
                last/=TFUN_NUM;
                {
                	tct(atRank(i % ts::realsuperSize));
                        dummy[i]=calc(first,last,args,*(all_res[i]));
                }
        }
        for (i=0;i<TFUN_NUM;i++) {
        	first=i*(ir+1);			//FIXME : possible bug?
                first/=TFUN_NUM;
                last=(i+1)*(ir+1);
                last/=TFUN_NUM;
                (int)dummy[i];
                memcpy(x1+first*FOUR*NC,all_res[i]->xn,(last-first)*FOUR*NC*sizeof(double));
                memcpy(y1+first*FOUR*NC,all_res[i]->yn,(last-first)*FOUR*NC*sizeof(double));
                //delete all_res[i];
        }
        //delete args;
        
        
   	temp=MPI_Wtime()-temp;
        
    	t3+=temp;
}
