

			     /*  3  */
			/*  step1.cpp  */

#include "cav.h"
#include <stdlib.h>
#include <math.h>
#include <stdio.h>

extern double kdL(unsigned i, double x);
extern void gaus1(unsigned i,unsigned j,int n,double r0,double z0,double z1);	                         
extern void nrnz(unsigned j,double x,double *nr,double *nz); 
extern void apgr1();
extern void om(double *a, double *b,unsigned n);
extern double ag[],x1[],x2[],x3[];
extern double *r,*z,*dz,*dr,*ds,*s,*u,*ka,*kb,*kc,*a,*b,*e0,*w11,*w0,*w1,*w2;
extern double mpi;
extern unsigned M,N,MN,MN1,MN2,mn1,K,k2,NY;
extern int nL;        

double step1()  
{
      unsigned i,j,k;          
      double r0,z0,z1,d,d1;	
      apgr1(); 
      for(i=0; i<MN; i++) {											   
   	    if(i<K) {
	  	  r0=r(i)+0.5*dr(i);
	          z0=0.125*ka(i)+0.25*kb(i)+0.5*kc(i)+z(i);
	    } else {
		  z0=z(i)+0.5*dz(i);
	          r0=0.125*ka(i)+0.25*kb(i)+0.5*kc(i)+r(i);
	    }
            z1=2.0*z(MN)-z0;			
	    b(i)=0.5*(z(MN)-z0);                                		
	    for(j=0; j<MN; j++) 
		    gaus1(i,j,nL,r0,z0,z1);                             
	    for(j=0;j<MN;j++) { 
	            a(i,j)=0.0;
	   	    b(i)+=e0(j)+w0(j);
	    } 
	    a(i,MN)=0.0;
            for(j=0;j<MN;j++) { 
	            d1=0.5*w2(j);
	            for(k=j;k<MN; k++)  {
		  	  d=d1*ds(k);
			  a(i,k)+=d;
		  	  a(i,k+1)+=d;
		    }
	            a(i,j)-=w1(j)-w11(j);
              	    a(i,j+1)-=w11(j);
	    }
	    for(k=i;k<MN;k++) {
	  	    d=0.25*ds(k);
		    a(i,k)+=d;
                    a(i,k+1)+=d;			
	    }
	    d=0.5*kdL(i,0.5);      
	    d1=d*d/ds(i);
            a(i,i)+=d1-d;
   	    a(i,i+1)-=d1;
      }
      for(i=0;i<MN;i++)
	    for(j=0;j<MN;j++) 
		    a(i,j)=a(i,j+1);
	 /*  end sikle on i, matrix has been done  */
      om(a,b,MN);
      for(i=0; i<MN; i++)
	    u(i+1)=b(i);
      u(0)=0.0;	
      return 0;       
}

