 //the class that hides the platform

#ifndef __WWAppTdef___
#define __WWAppTdef___

#include "windpoint.h"


template <class WWBodyT,class WWWndfldT> class WWApplicationT
    {
	public:	
		
		int Init(int a,char **b);

		//implementation function
    		int Implement();
    
		virtual int SetWorkTime();
		virtual int SavePrepare();
		virtual int SaveResults(WWBodyT *body,WWWndfldT *wf);	
		virtual int SaveStepResults(WWBodyT *body,
					    WWWndfldT *wf,
					    double time);

		int Abort(int errno);


	private:
	    int argc;
	    char **argv;
	
        protected:
	    double time_start;
	    double time_end;
	    double time_step;
	};

#endif 
