//class WindField that contains all free wirlwinds and all functions
//to computate various wirlwinds characteristics


#ifndef __WWWindfldTdef___
#define __WWWindfldTdef___

#include "windpoint.h"
#include "t_getfield.h"

// __step_=__nums_


template <int __choice_,int __NP_,int __step_,int __MAX_R_> class WWWindFieldT
    {
	public:
	    Wind fwnd[__MAX_R_];
	    Wind fwndnew[__MAX_R_];
	    
	    int nprev;
	    int n;		//the current amount  of free wirlwinds
	
	    int step;
	    int NNP;
	    

	    Vector ospeedvec[__MAX_R_];
	    
	    Point center;
	    double source;
	    Wind s;

	    Wind awnd[__NP_+__choice_];	//the attached wirlwinds that we need to
				//count new charactristics of the free winds
	
	    //here the constructor goes		
	    WWWindFieldT();

	    
	    void ospeed(double xx,double yy,Wind *awnd,Point center,
	    double source,double *wxx,double *wyy);
			
	     void speedf(double,double,double,double,double*,double*);
	     void speed(double,double,double,double,double*,double*);
	     void speed2f(double,double,double,double,double*,double*);
	     void speed2(double,double,double,double,double*,double*);
	     void speedi(double,double,double,double,double*,double*);
	    

	     int CountFreeWinds(double ts);
	    int CountFunc(int i,double ts,double ,double);

	void getospeedvec(Wind*awnd,Point center,double source)
	{
#define S MAX((__NP_+__choice_)*sizeof(Wind),n*sizeof(Wind))
	tct(extraSize(S));
	tval short fwnd_=0, awnd_=0,res[R];
	int i;
	memcpy(&(short&)fwnd_,fwnd,n*sizeof(Wind));
	memcpy(&(short&)awnd_,awnd,(__NP_+__choice_)*sizeof(Wind));
	 for (i=0;i<R;i++)
  	  res[i]=t_getfield(i,n,fwnd_,awnd_,center,source);
	for (i=0;i<R;i++)
	{
	int start=i*n/R, stop=(i+1)*n/R;
	  memcpy(ospeedvec+start,(Vector*)&(short&)(res[i])+start,(stop-start)*sizeof(Vector));
	}

	}

    };


#endif
