/* ⮤  襭 ⥬  ࠢ 
 *  롮஬ ᨬ쭮    
 *  ᥩ 
 */
#ifndef __Gauss___
#define __Gauss___

#include <malloc.h>
#include <math.h>

/*
int printline(double *a,int n)
    {
    
	int i;
	
	for (i=0;i<n;i++)
	    printf("%lf ",a[i]);
	    
	return 0;
    }
*/
template <int __choice_,int __NP_,int __numc_,
			    class WWWFieldT>
int WWBodyT<__choice_,__NP_,__numc_,WWWFieldT>::
    printmatrix(double *a,int n)
    {
	int i,j;
	
	printf("\nMatrix is:\n");
	for (i=0;i<n;i++)
	    {
		for (j=0;j<n;j++)
		    if (a[i*n+j]>=0)
		    printf(" %lf ",a[i*n+j]);
		    else
		    printf("%lf ",a[i*n+j]);
		    
		printf("\n");
	    }
    
    
    
	return 0;
    
    }


template <int __choice_,int __NP_,int __numc_,
			    class WWWFieldT>
inline int WWBodyT<__choice_,__NP_,__numc_,WWWFieldT>
	::swaplines(double *a,double *,int *ind,int n,int i,int j)
    {
	double temp;
	int k;
	
	
	for (k=0;k<n;k++)
	    {
		temp=a[i*n+k];
		a[i*n+k]=a[j*n+k];
		a[j*n+k]=temp;
	    }
	
	k=ind[i];
	ind[i]=ind[j];
	ind[j]=k;

	return 0;
    };

template <int __choice_,int __NP_,int __numc_,
			    class WWWFieldT>
inline int WWBodyT<__choice_,__NP_,__numc_,WWWFieldT>
	::swapcolumns(double *a,double *y,int *,int n,int i,int j)
    {
	double temp;
	int k;
	
	for (k=0;k<n;k++)
	    {
		temp=a[k*n+i];
		a[k*n+i]=a[k*n+j];
		a[k*n+j]=temp;
	    }

	temp=y[i];
	y[i]=y[j];
	y[j]=temp;

    	return 0;
    };

template <int __choice_,int __NP_,int __numc_,
			    class WWWFieldT>
 int WWBodyT<__choice_,__NP_,__numc_,WWWFieldT>
	::Gauss(double *a,double *x,int n)
    {
	int i,j,k;
	int imax,jmax;
	double max,*y;
	int *ind;
	
	ind=(int *)malloc(n*sizeof(int));	// :))
	y=(double *)malloc(n*sizeof(double)); 	// :))
	
	if ( !ind || !y) return 1;
	
	
	for (i=0;i<n;i++) 
	    {
		ind[i]=i;
		y[i]=x[i];
	    }
	
    //forward
    
	for (k=0;k<n;k++)
	    {
		max=fabs(a[k*n+k]);
		imax=k;
		jmax=k;

		for (i=k;i<n;i++)
		    for (j=k;j<n;j++)
			if (fabs(a[i*n+j])>max)
			    {
				max=fabs(a[i*n+j]);
				imax=i;
				jmax=j;
				    
			    }        

		
			    
		swaplines(a,y,ind,n,imax,k);
		swapcolumns(a,y,ind,n,k,jmax);
		
		y[k]/=a[k*n+k];
		

		for (i=n-1;i>=k;i--)
		    {
			a[i*n+k]/=a[k*n+k];
		    }
		
		for (i=k+1;i<n;i++)
		    {
			y[i]-=y[k]*a[k*n+i];
					    
		    	for (j=n-1;j>=k;j--)
			    {
				a[j*n+i]-=a[j*n+k]*a[k*n+i];
			    }
		    }
	    
	    }
    //back
    
	    for (i=n-1;i>=0;i--)
		{
		for (j=i+1;j<n;j++)
		    y[i]-=a[j*n+i]*y[j];
		}
		    
		
		    
	    for (i=0;i<n;i++)
		x[ind[i]]=y[i];
    
    
    
	free(ind);
	free(y);
    	return 0;
    };

#endif
