/* mary */
#ifndef __DRAW_H__
#define __DRAW_H__

#include <gnome.h>
#include <dotneato.h>

//#define FONT "-adobe-courier-bold-r-normal--14-100-100-100-m-90-iso8859-1"
#define FONT "-adobe-helvetica-bold-r-normal--14-100-100-100-p-82-iso8859-1"
#define FONTSIZE "14"
#define FONTNAME "Helvetica"
#define FONTCOLOR "black"
#define FILLCOLOR "white"
#define COLOR "black"
#define STYLE "filled"
#define LINE_STYLE "solid"
#define CANVAS_WIDTH 800
#define CANVAS_HEIGHT 600

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

typedef struct GraphCanvas {
  double canvas_height, canvas_width;
  double culc_height, culc_width;
  double x_offset, y_offset;
  GList *item_list;
  GtkWidget *canvas;
} GraphCanvas;

GraphCanvas *
create_canvas();

void
draw_graph(Agraph_t *g, GraphCanvas *canvas);

#ifdef __cplusplus
	   }
#endif /* __cplusplus */

#endif
/* end of mary */
