#ifndef __PROF_H__

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>

enum {
  PROF_UNDEF,
  PROF_NONE,
  PROF_ACTIVE,
  PROF_SCREEN,
  PROF_WINDOW,
  PROF_BOTH
};

int prof_com_server(char *server, int port, int output);
int prof_com_client(char *server, int port, char *message);
int prof_get_stat(char *server, int port, char *funcname);
void prof_print_stat(char *message);
void local_hostname(char *hostname);

#define __PROF_H__
#endif
