#ifndef __XRPOF_H__

#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <sys/types.h>
#include <errno.h>
#include <gtk/gtk.h>

struct xprof_env {
  char server[256];
  int port;
  pid_t parent;
  GtkWidget *stat_lst;
  gint sort_col;
  GtkSortType sort_type;
  int rows;
  char row_data[1024];
};

struct xprof_env env;

int xprof_com_server();
int xprof_com_client(char *message);

void xprof_show_stat();
void xprof_sort_stat();

#define __XPROF_H__
#endif
