#include "xprof.h"

/********************************************************************/

void xprof_sort_stat()
{
  gtk_clist_set_sort_column(GTK_CLIST(env.stat_lst), env.sort_col);
  gtk_clist_set_sort_type(GTK_CLIST(env.stat_lst), env.sort_type);
  gtk_clist_sort(GTK_CLIST(env.stat_lst)); 
}

/********************************************************************/

void xprof_show_stat()
{
  if (env.row_data[0] == '\0')
    return;

  char node[256], func[256];
  pid_t pid;
  double utime, stime;
  unsigned long rss;
  sscanf(env.row_data, "%s %d %s %lf %lf %lu", node, &pid, func, &utime, &stime, &rss);

  gchar *row[6];
  row[0] = g_strdup(node);
  row[1] = g_strdup_printf("%d", pid);
  row[2] = g_strdup(func);
  row[3] = g_strdup_printf("%lf", utime);
  row[4] = g_strdup_printf("%lf", stime);
  row[5] = g_strdup_printf("%lu", rss);

  gtk_clist_prepend(GTK_CLIST(env.stat_lst), row);
  xprof_sort_stat();
  env.rows ++;
  env.row_data[0] = '\0';
}
