/* CORRI.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/
//#include "/home/potemkin/autoInstallOpenTS/openTS/opentss/trt"
//#include "/home/potemkin/autoInstallOpenTS/openTS/opentss/txx"
#ifdef __cplusplus
extern "C" {
#endif
#include "f2c.h"

// in  - ni, mi, xix, yiy
// out - d, rrr, si
struct SInData{
	doublereal xix[400000];
	doublereal yiy[1000];
	integer ni, mi;
};

struct SOutData{
	doublereal d[376];
	doublereal rrr, si;
};
// int corrida_(integer *ni, integer *mi, doublereal *xix, 
//	doublereal *yiy, doublereal *d__, doublereal *rrr, doublereal *si)
//
tptr SInData /*tptr*/ pdata;

tfun int corrida_(SInData pInData, tout SOutData pOutData)
{
    static SInData InData = pInData;;
    static SOutData OutData;
    doublereal *xix = InData.xix;
    doublereal *yiy = InData.yiy;
    integer *ni = &InData.ni;
    integer *mi = &InData.mi;
    doublereal *d__ = OutData.d;
    doublereal *rrr = &OutData.rrr;
    doublereal *si = &OutData.si;

    /* System generated locals */
    integer i__1, i__2, i__3;
    doublereal d__1;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    static doublereal sumy, c__;
    static integer i__, j;
    static doublereal y, de, ai[160000]	/* was [400][400] */;
    static integer kk;
    static doublereal xi[400000]	/* was [1000][400] */, sx, sy, sxx, 
	    sxy, syy;

/* Multiple regression */
    /* Parameter adjustments */
    --d__;
    --yiy;
    xix -= 1001;

    /* Function Body */
    sumy = (float)0.;
    i__1 = *ni;
    for (i__ = 1; i__ <= i__1; ++i__) {
	xi[i__ - 1] = (float)1.;
	i__2 = *mi;
	for (j = 1; j <= i__2; ++j) {
	    xi[i__ + (j + 1) * 1000 - 1001] = xix[i__ + j * 1000];
	}
/* L99: */
    }
/* L878: */
    i__1 = *mi + 1;
    for (i__ = 1; i__ <= i__1; ++i__) {
	i__2 = *mi + 1;
	for (j = 1; j <= i__2; ++j) {
	    ai[i__ + j * 400 - 401] = (float)0.;
	    i__3 = *ni;
	    for (kk = 1; kk <= i__3; ++kk) {
		ai[i__ + j * 400 - 401] += xi[kk + i__ * 1000 - 1001] * xi[kk 
			+ j * 1000 - 1001];
	    }
	}
/* L100: */
    }
    i__1 = *mi + 1;
    for (i__ = 1; i__ <= i__1; ++i__) {
	ai[i__ + (*mi + 2) * 400 - 401] = (float)0.;
	i__2 = *ni;
	for (j = 1; j <= i__2; ++j) {
	    ai[i__ + (*mi + 2) * 400 - 401] += yiy[j] * xi[j + i__ * 1000 - 
		    1001];
	}
    }
    i__1 = *mi;
    for (i__ = 1; i__ <= i__1; ++i__) {
	i__2 = *mi + 1;
	for (j = i__ + 1; j <= i__2; ++j) {
	    c__ = ai[j + i__ * 400 - 401] / ai[i__ + i__ * 400 - 401];
	    i__3 = *mi + 2;
	    for (kk = 1; kk <= i__3; ++kk) {
		ai[j + kk * 400 - 401] -= ai[i__ + kk * 400 - 401] * c__;
	    }
	}
/* L104: */
    }
    d__[*mi + 1] = ai[*mi + 1 + (*mi + 2) * 400 - 401] / ai[*mi + 1 + (*mi + 
	    1) * 400 - 401];
    for (i__ = *mi; i__ >= 1; --i__) {
	i__1 = *mi + 1;
	for (j = i__ + 1; j <= i__1; ++j) {
	    ai[i__ + (*mi + 2) * 400 - 401] -= d__[j] * ai[i__ + j * 400 - 
		    401];
	}
	d__[i__] = ai[i__ + (*mi + 2) * 400 - 401] / ai[i__ + i__ * 400 - 401]
		;
/* L105: */
    }
    sx = (float)0.;
    sy = (float)0.;
    sxy = (float)0.;
    syy = (float)0.;
    sxx = (float)0.;
    *si = (float)0.;
    i__1 = *ni;
    for (i__ = 1; i__ <= i__1; ++i__) {
	y = (float)0.;
	i__2 = *mi + 1;
	for (j = 1; j <= i__2; ++j) {
	    y += d__[j] * xi[i__ + j * 1000 - 1001];
	}
	de = yiy[i__] - y;
	*si += de * de;
	sx += yiy[i__];
	sy += y;
	sxy += yiy[i__] * y;
	sxx += yiy[i__] * yiy[i__];
	syy += y * y;
/* L106: */
    }
    d__[188] = d__[1];
    i__1 = *mi;
    for (j = 1; j <= i__1; ++j) {
	d__[j] = d__[j + 1];
    }
/*    si = Sqrt(si/(ni-mi-1)) */
    if (((real) (*ni) * syy - sy * sy) * ((real) (*ni) * sxx - sx * sx) > (
	    float)0.) {
	*rrr = (d__1 = (real) (*ni) * sxy - sx * sy, abs(d__1)) / sqrt(((real)
		 (*ni) * syy - sy * sy) * ((real) (*ni) * sxx - sx * sx));
    }
    pOutData = OutData;
    //return 0;
} /* corrida_ */

#ifdef __cplusplus
	}
#endif
