#include <stdio.h>
#include <stdlib.h> //?

//#define TRACE

#ifndef TRACE
tfun int fib (int n) {
  return n < 2  ?  n : fib(n-1)+fib(n-2);
}
#else
tfun int fib (int n, int m) {
  tct(setLabel("(%d)",n));
  int rk = ts::myRank;
  int res = n < 2  ?  n : fib(n-1,rk)+fib(n-2,rk);
  fprintf (stderr, "[%d -> %d] fib(%d) = %d\n", rk, m, n, res);
  return res;
}
#endif

tfun int main (int argc, char *argv[]) {
  if (argc != 2) { printf("Usage: fib <n>\n"); return 1; }
  int n = atoi(argv[1]);
#ifndef TRACE
  printf("fib(%d) = %d\n", n, (int)fib(n));
#else
  printf("fib(%d) = %d\n", n, (int)fib(n,0));
#endif
  return 0;
}
