Name:           dmpi
Summary:        DMPI--Dynamic MPI implementation
Version:        0.0.0
Release:        1
Copyright:      GPL
Group:          Development/Libraries
Source:	        %{name}-%{version}.tar.gz
BuildRoot:	/var/tmp/%{name}-%{version}-root
Provides:       dmpi
Prefix:         /usr/local
%define _prefix /usr/local

%description 
DMPI--Dynamic MPI implementation

%prep
%setup -q

echo "CFLAGS = -g -O0 -fno-inline" > Makefile.tmp
sed 's/^include/#include/' Makefile >> Makefile.tmp
mv Makefile.tmp Makefile

%build
CFLAGS="$RPM_OPT_FLAGS" make

%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{_libdir}
mkdir -p $RPM_BUILD_ROOT%{_includedir}/%{provides}

cp -r *.a *.so $RPM_BUILD_ROOT%{_libdir}
cp -r dmpi.h $RPM_BUILD_ROOT%{_includedir}/%{provides}/mpi.h

%files
%defattr (-, root, root)
%{_libdir}/*
%{_includedir}/%{provides}/*


%changelog
* Tue Jul 2 2002 Max Kovalenko <madmax@skif.botik.ru>
- created spec file

