extern "C" {
  void registerFeature(const char *name, const char *comment, void *(*entry)(int, void *));
  int checkpoint_init(int argc, char **argv);
}

class CkptInit {
public:
  static void *entry(int cmd, void *arg) {
    if (cmd)
      checkpoint_init(cmd, (char **) arg);
    return 0;
  }
  CkptInit() {
    registerFeature("ckpt", "Checkpoint / restart support", entry);
  }
} ckptinit;
