//                                                          
//           0,1,0 o-----------o 1,1,0        y
//                 |\          |\            ^
//                 | \         | \           |
//           0,1,1 |  o-----------o 1,1,1    |
//                 |  |        |  |          |
//                 |  |        |  |          |
//           0,0,0 o--|--------o  | 1,0,0    o---------->x                   
//                  \ |         \ |           \         
//                   \|          \|            \            
//              0,0,1 o-----------o 1,0,1       \
//                                               \ z

#include <stdio.h>

struct cubeNode {
       tptr cubeNode x;
       tptr cubeNode y;
       tptr cubeNode z;
       tval int data;
};

int 
cubeShow(cubeNode cube[][2][2])
{
  printf("     %3d o-----------o %-3d\n", cube[0][1][0].data, cube[1][1][0].data); 
  printf("         |\\          |\\\n");       
  printf("         | \\         | \\\n");           
  printf("     %3d |  o-----------o %-3d\n", cube[0][1][1].data, cube[1][1][1].data);    
  printf("         |  |        |  |\n");
  printf("         |  |        |  |\n");
  printf("     %3d o--|--------o  | %-3d\n", cube[0][0][0].data, cube[1][0][0].data);                  
  printf("          \\ |         \\ |\n");        
  printf("           \\|          \\|\n");            
  printf("        %3d o-----------o %-3d\n", cube[0][0][1].data, cube[1][0][1].data);
  printf("\n");
  
  return(0);
}

tfun int 
tfn(tval cubeNode cubeNd[][2][2])
{
  cubeShow(cubeNd);

  return(0);  
}

tfun int 
main(int argc, char *argv[])
{
  tval cubeNode cn[2][2][2];
   
  for (int i = 0; i < 2; i++)
   for (int j = 0; j < 2; j++)
    for (int k = 0; k < 2; k++) {
         cn[i][j][k].x = &cn[1-i][j][k];       
         cn[i][j][k].y = &cn[i][1-j][k];
         cn[i][j][k].z = &cn[i][j][1-k];
         cn[i][j][k].data = i + j + k;
    }

  tfn(cn);
  cn[0][1][0].data = 100;
  tfn(cn);
  cn[0][1][0].data = 200;
  tfn(cn);
  cn[0][1][0].data = 300;
  tfn(cn);

  return(0); 
}
